/*-
 * Copyright (C) 2006 Erik Larsson
 * 
 * All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */

package org.catacombae.jab;

import org.catacombae.jab.gui.ProgressIndicatorPanel;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ProgressDialog extends JDialog {
    private boolean opened = false;
    private ProgressIndicatorPanel pip;

    public ProgressDialog(Frame owner, boolean modal) {
	super(owner, modal);
	pip = new ProgressIndicatorPanel();
	
	pip.progressBar.setMinimum(0);
	pip.progressBar.setMaximum(Integer.MAX_VALUE);
	pip.progressBar.setStringPainted(true);
	pip.progressBar.setValue(0);
	pip.progressBar.setString("0%");
// 	pip.cancelButton.addActionListener(new ActionListener() {
// 		setVisible(false);
// 	    });
	
	add(pip, BorderLayout.CENTER);
	pack();
	setLocationRelativeTo(null);
    }
    
    public void setVisible(boolean b) {
	if(b && opened)
	    return;

	opened = true;
	
	super.setVisible(b);
    }
    
    public void setMessage(String msg) {
	pip.statusLabel.setText(msg);
    }

    public void setProgress(double percentage) {
	pip.progressBar.setValue((int)(percentage*Integer.MAX_VALUE));
	pip.progressBar.setString((int)(percentage*100) + "%");
    }
    
    public void addCancelButtonListener(ActionListener al) {
	pip.cancelButton.addActionListener(al);
    }
}
